// File: fastSearch.c
//
// Created: Sat Dec 27 18:12:12 2003
//
// $Id: SDB.h,v 1.3 2004/05/14 09:32:58 sav Exp $
//

#ifndef __MAIN_SDB_H__
#define __MAIN_SDB_H__

//#include <iostream>
//#include <vector>

#include "typedefs.h"
#include "nrif.h"
#include "sdb_header.h"
#include "sdb_error.h"
#include "cmps_light.h"
#include "iterator.h"

class SDB {
  sdb_header nr;
  NodeRIndex<noid_type,noid_type> *state;
public: 
  SDB(const char* name) : nr(name), state(NULL) {}

  void reset(void) {
    if(state != NULL) delete state;
    state = nr.get_nrif();
  }

  NodeRIndex<noid_type,noid_type> *current(void) {return state;}

  bool exists_at(uint4 noid) {
    std::pair< ll_tb_iter, ll_tb_iter > res = state->get(noid);
    if (res.first.is_end()) return false;
    return true;
  }

  void set_next(uint4 noid) {
    if (state->get_valtype()!=NodeConst::CONTEXT4 ) throw sdb_error("Bad noid found!");
//       std::cerr << "Type: " << state->get_type() << "\n";
    std::pair< ll_tb_iter, ll_tb_iter > res = state->get(noid);
    if (res.first.is_end()) throw sdb_error_no_path(noid);
    if (res.second - res.first > 1) throw sdb_error("Bad path: multi context ?");
    char* next_node =state->get_top()+ state->get_get_map().get_val(res.first.get_cur());
    state -> init(next_node);
  }

};

#endif

//  Local Variables:
//  mode: c++
//  End:
